package src.hw1;

public class Acela {
	public final static int MAXSET= 20;	// Maximum train sets handled in program
	private Trip[] trip;
	private int turnTime;
	private TrainSet[] trainset;
	public static final String[] name= {"BOS", "NYP", "WAS"};
	
	public Acela(Trip[] tr, int tt){
		trip= tr;
		turnTime= tt;
		trainset= new TrainSet[MAXSET];
		TrainSet.lastTrainSet= -1;		// Reset highest trainset number
	}
	
	public int getTrainsets() {
		// Assign first trip to first train set to start algorithm
		trainset[0]= new TrainSet(trip[0]);
		// Loop through departures in time order. Start with trip 1; trip 0 is already assigned
		for (int i= 1; i < trip.length; i++) {					// Trip number i 
			boolean trainsetFound= false;						// No train set found yet to cover it
			for (int j= 0; j <= TrainSet.lastTrainSet; j++) {	// Loop thru all train sets that exist so far
				TrainSet ts= trainset[j];						// Get the TrainSet
				int trainsetDest= ts.getDest();					// Get destination of last trip TrainSet is covering
				int tripOrigin= trip[i].orig;					// Get origin of trip to be covered
				int trainsetAvailTime= ts.getArrive() + turnTime;	// Get arrival time of last trip TrainSet is covering + turn time
				int tripStartTime= trip[i].depart;				// Find departure time of trip to be covered
				if (trainsetDest == tripOrigin && trainsetAvailTime <= tripStartTime) {
					// If TrainSet destination is same as trip origin and trainset available before trip is due to depart,
					// add this trip as last trip for this trainset. (There may be more trips added to TrainSet later)
					ts.addTrip(trip[i]);
					trainsetFound= true;
					break;
				}
			}
			if (!trainsetFound) {
				TrainSet ts1= new TrainSet(trip[i]);
				trainset[TrainSet.lastTrainSet]= ts1;
			}
		}
		return TrainSet.lastTrainSet+1;
	}
	
	public void printTrainSets() {
		System.out.println("Trainset : trips");
		for (int i= 0; i <= TrainSet.lastTrainSet; i++) {
			TrainSet t= trainset[i];
			System.out.print((i+1) + " : ");
			for (int j= 0; j <= t.currTrip; j++) {
				Trip current= t.trips[j];
				System.out.print("Trip " + (current.tripNbr+1) + " (");
				System.out.print(name[current.orig]+" "+ name[current.dest]+" ");
				System.out.print("Dp "+ current.depart + "00 Ar "+ current.arrive+"00) ");
			}
			System.out.println();
		}
		System.out.println("\nCurrent schedule with "+ turnTime + 
				" hour turnaround requires " + (TrainSet.lastTrainSet+1) + " trainsets");
	}
}